#ifndef _CRYPTUTIL_H_
#define _CRYPTUTIL_H_
#include <vector>
#include <string>
#include <utility>


typedef unsigned char BYTE;
namespace cryptutil
{
    bool DecodeString(const std::string&, std::vector<BYTE>&);
    bool DecodeFile(const std::string&, const std::string&);
    std::string DecodeAndDecryptFile(const std::string&, const std::string&, const std::string& = "");
    std::string DecodeAndDecryptString(const std::string&, const std::string&, const std::string& = "");

    // Custom exception class
	class cryptutilException : public std::exception
	{
        std::string exMessage;
	public:
        cryptutilException(const std::string& errDetail)
            : exMessage(errDetail)
        {}
        virtual const char* what() const throw()
        {
            return exMessage.c_str();
        }
    };
}
#endif